[![logo](https://www.hongsnet.net/images/logo.gif)](https://www.hongsnet.net)

# www.hongsnet.net Source Deploy

![source_overview](./images/hongsnet-source-deploy.png)


## 구성 요소

*  Git and GitLab (gitlab-ci.yml)
*  gitlab-runner
*  Docker


# GitLab Runner Overview

Runner는 yaml을 파일을 수행한다. 특정 프로젝트에 국한되거나, 여러 프로젝트에서 사용할 수 있도록 제공된다. 여기서 모든 여러 프로젝트에서 사용할 수 있는 Runner를 **Shared Runner**이라고 하며, 특정 프로젝트에 국한되서 사용되는 Runner를 **Specific Runner**라고 한다.

홍쓰넷 소스배포에는 `Specific Runner`를 사용한다.


```plaintext
!참고 : Shared 와 Specific Runner의 차이

Specific Runner는 특정 Project에서만 사용할 수 있다. 

이는 여러 프로젝트에서 사용가능한 Shared Runner와의 가장 큰 차이점이다. 
즉, 여러 프로젝트에서 유사한 Job을 수행할 경우에는 Shared Runner가 권장되며, 
특별한 Job이 있는 경우에는 Specific Runner가 권장된다. 

예를 들어, 만약 특정 프로젝트를 Deploy할 때 이를 위한 프로젝트 별로 권한을 지정해야 한다면, 
Specific Runner를 통해 Job을 수행하는 것이다.
```

## GitLAB Runner Install

- redhat 계열

```bash
# curl -L https://packages.gitlab.com/install/repositories/runner/gitlab-runner/script.rpm.sh | bash

# yum install gitlab-runner

# gitlab-runner register
Runtime platform arch=amd64 os=linux pid=3037 revision=ac8e767a version=12.6.0
Running in system-mode.
```

- Debian 계열



## GitLAB Runner Register


```bash
Please enter the gitlab-ci coordinator URL (e.g. https://gitlab.com/):
https://gitlab.hongsnet.net
Please enter the gitlab-ci token for this runner:
M4y6veuzG2VG_nH7ZSdh
Please enter the gitlab-ci description for this runner:
[TB2.hongsnet.net]:
Please enter the gitlab-ci tags for this runner (comma separated):
deploy
Registering runner... succeeded runner=M4y6veuz
Please enter the executor: kubernetes, docker, docker-ssh, parallels, shell, ssh, virtualbox, custom, docker+machine, docker-ssh+machine:
shell
Runner registered successfully. Feel free to start it, but if it's running already the config should be automatically reloaded!
```






